#include <windows.h>
#include "hspdll.h"

#ifndef _DEBUG
#pragma comment (linker, "/opt:nowin98 /nodefaultlib /entry:\"DllMain\"")
#endif

#define MAX_LINE 128
#define MAX_BUF 8

HMODULE hModule;
int WINAPI DllMain( HANDLE hModule, 
	DWORD  ul_reason_for_call, 
	LPVOID lpReserved)
{
	return TRUE;
}


// f[^̐
int idatas;
int odatas;
// ̃f[^
int idatasb;
int odatasb;
int i_devid = WAVE_MAPPER; // ̓fBoCX
int o_devid = WAVE_MAPPER; // o̓fBoCX
WAVEHDR iwh[MAX_BUF];
WAVEHDR owh[MAX_BUF];
HWAVEOUT hWOut=NULL;
HWAVEIN hWIn=NULL;

// R[obN֐
void CALLBACK wavProc2(HWAVEOUT hwo,UINT msg,DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
    switch(msg){
	case MM_WIM_DATA: // ^I
		waveInUnprepareHeader(hWIn,&iwh[idatasb&7],sizeof(WAVEHDR));
		idatasb++;
		return;

	case MM_WOM_DONE: // ĐI
		waveOutUnprepareHeader(hWOut,&owh[odatasb&7],sizeof(WAVEHDR));
		odatasb++;
		return;
    }
}



// c̃obt@̐
EXPORT BOOL WINAPI w_in_bufs(int *v, int p2, int p3, int p4)
{
	*v = idatas-idatasb&7;
	return 0;
}
EXPORT BOOL WINAPI w_out_bufs(int *v, int p2, int p3, int p4)
{
	*v = odatas-odatasb&7;
	return 0;
}

// 
EXPORT BOOL WINAPI w_in_close(int freq, int bits, int chs, int p4)
{
	if(hWIn){
		waveInClose(hWIn);
		hWIn=NULL;
	}
	idatas=0;
	idatasb=0;
 	return 0;
}
EXPORT BOOL WINAPI w_out_close(int p1, int p2, int p3, int p4)
{
	if (hWOut) {
		waveOutClose(hWOut);
		hWOut = NULL;
	}
	odatas = 0;
	odatasb = 0;
	return 0;
}
// SĊJ
EXPORT BOOL WINAPI w_free(int p1, int p2, int p3, int p4 )
{
	w_in_close(0,0,0,0);
	w_out_close(0,0,0,0);
	return 0;
}




/*
	J
	freq: TvOg
	bits: rbg
	chs: `l
*/
EXPORT BOOL WINAPI w_in_open(int freq, int bits, int chs, int p4)
{
	w_in_close(0,0,0,0);
	int i;
	// 
	for(i=0;i<8;i++){
		//iwh[i].lpData=(char *)lpBuf;
		//iwh[i].dwBufferLength=p4;
		iwh[i].dwBytesRecorded=0;
		iwh[i].dwUser=0;
		iwh[i].dwFlags=0;
		iwh[i].dwLoops=1;
		iwh[i].lpNext=NULL;
		iwh[i].reserved=0 ;
	}

	static WAVEFORMATEX wf;
	wf.wFormatTag=WAVE_FORMAT_PCM;
	wf.nChannels=1;
	wf.nSamplesPerSec=8000;
	wf.nAvgBytesPerSec=16000;
	//wf.nBlockAlign=1;
	wf.wBitsPerSample=16;
	wf.cbSize=0;
	if(chs) wf.nChannels=chs;
	if(bits) wf.wBitsPerSample=bits;
	if(freq){
		wf.nSamplesPerSec=freq;
		wf.nAvgBytesPerSec=freq*wf.wBitsPerSample/8*wf.nChannels;
	}
	wf.nBlockAlign=wf.nChannels * wf.wBitsPerSample / 8;
	i=waveInOpen(&hWIn,i_devid,&wf,(DWORD)wavProc2,0,CALLBACK_FUNCTION);
	if(i!=MMSYSERR_NOERROR)
		return -1;
 	return 0;
}

/*
	obt@o^
	buf obt@ւ̃|C^
	len oCg
	f ĐJntO
*/
EXPORT BOOL WINAPI w_in_add(char* buf, int len, int f, int p4 )
{
	iwh[idatas&7].lpData=buf;
	iwh[idatas&7].dwBufferLength=len;
	int i=waveInPrepareHeader(hWIn,&iwh[idatas&7],sizeof(WAVEHDR));
	if(i!=MMSYSERR_NOERROR)
		return -1;
	i=waveInAddBuffer(hWIn,&iwh[idatas&7],sizeof(WAVEHDR));
	if(i!=MMSYSERR_NOERROR)
		return -1;
	idatas++;
	if(f)waveInStart(hWIn);
	return 0;
}


/*
	J
	freq: TvOg
	bits: rbg
	chs: `l
*/
EXPORT BOOL WINAPI w_out_open(int freq, int bits, int chs, int p4)
{
	w_out_close(0,0,0,0);
	int i;
	// 
	for (i=0;i<8;i++) {
		//owh[i].lpData=(char *)lpBuf;
		//owh[i].dwBufferLength=p4;
		owh[i].dwBytesRecorded=0;
		owh[i].dwUser=0;
		owh[i].dwFlags=0;
		owh[i].dwLoops=1;
		owh[i].lpNext=NULL;
		owh[i].reserved=0 ;
	}

	static WAVEFORMATEX wf;
	wf.wFormatTag=WAVE_FORMAT_PCM;
	wf.nChannels=1;
	wf.nSamplesPerSec=8000;
	wf.nAvgBytesPerSec=16000;
	//wf.nBlockAlign=1;
	wf.wBitsPerSample=16;
	wf.cbSize=0;
	if (chs) wf.nChannels=chs;
	if (bits) wf.wBitsPerSample=bits;
	if (freq) {
		wf.nSamplesPerSec=freq;
		wf.nAvgBytesPerSec=freq*wf.wBitsPerSample/8*wf.nChannels;
	}
	wf.nBlockAlign=wf.nChannels * wf.wBitsPerSample / 8;
	i = waveOutOpen(&hWOut,o_devid,&wf,(DWORD)wavProc2,0,CALLBACK_FUNCTION);
	if (i!=MMSYSERR_NOERROR)
		return -1;
	return 0;
}


/*
	obt@o^
	buf obt@ւ̃|C^
	len oCg
	f ĐJntO
*/
EXPORT BOOL WINAPI w_out_add(char* buf, int len, int f, int p4 )
{
	owh[odatas&7].lpData = buf;
	owh[odatas&7].dwBufferLength = len;
	int i = waveOutPrepareHeader(hWOut,&owh[odatas&7],sizeof(WAVEHDR));
	if (i!=MMSYSERR_NOERROR)
		return -1;
	i = waveOutWrite(hWOut,&owh[odatas&7],sizeof(WAVEHDR));
	if (i!=MMSYSERR_NOERROR)
		return -2;
	odatas++;
	return 0;
}







////////////////////////////////////////////////////////////////////////////
//  ~LT[֘A
////////////////////////////////////////////////////////////////////////////

// fBoCX̐擾
EXPORT BOOL WINAPI w_in_getdevs(int *v, int p2, int p3, int p4)
{
	*v = waveInGetNumDevs();
	return 0;
}
EXPORT BOOL WINAPI w_out_getdevs(int *v, int p2, int p3, int p4)
{
	*v = waveOutGetNumDevs();
	return 0;
}

// fBoCXI
EXPORT BOOL WINAPI w_in_seldev(int dev, int p2, int p3, int p4)
{
	if (dev<0) dev = WAVE_MAPPER;
	i_devid = dev;
	return 0;
}
EXPORT BOOL WINAPI w_out_seldev(int dev, int p2, int p3, int p4)
{
	if (dev<0) dev = WAVE_MAPPER;
	o_devid = dev;
	return 0;
}


// fBoCX̖O擾
EXPORT LONG WINAPI w_in_getdevname(char* buf, int dev, int p3, int p4)
{
	WAVEINCAPS woc;
	waveInGetDevCaps(dev,&woc,sizeof(WAVEINCAPS));
	strcpy(buf,woc.szPname);
	return 0;
}
EXPORT LONG WINAPI w_out_getdevname(char* buf, int dev, int p3, int p4)
{
	WAVEOUTCAPS woc;
	waveOutGetDevCaps(dev,&woc,sizeof(WAVEOUTCAPS));
	strcpy(buf,woc.szPname);
	return 0;
}

// ̓C̐
EXPORT BOOL WINAPI w_in_getlines(int *v, int dev, int p3, int p4)
{
	MIXERLINE mxline;
	memset(&mxline,0,sizeof(mxline));
	mxline.cbStruct = sizeof(mxline);
	mixerGetLineInfo((HMIXEROBJ)dev,&mxline,MIXER_OBJECTF_WAVEIN);
	*v = mxline.cConnections;
	return 0;
}

// C̖O
EXPORT BOOL WINAPI w_in_getlinename(char *buf, int dev, int line, int p4)
{
	// C
	MIXERLINE mxl;
	mxl.cbStruct = sizeof(MIXERLINE);
	mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN;
	if(mixerGetLineInfo((HMIXEROBJ)dev,&mxl,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINEINFOF_COMPONENTTYPE)!=MMSYSERR_NOERROR)
			return -1;

	// Rg[ID擾
	MIXERCONTROL mxc;
	MIXERLINECONTROLS mxlc;
	memset(&mxlc,0,sizeof(mxlc));
	mxlc.cbStruct = sizeof(MIXERLINECONTROLS);
	mxlc.dwLineID = mxl.dwLineID;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_MUX;
	mxlc.cControls = 1;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL);
	mxlc.pamxctrl = &mxc;

	if (mixerGetLineControls((HMIXEROBJ)dev,&mxlc,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINECONTROLSF_ONEBYTYPE)!=MMSYSERR_NOERROR)
			return -1;
	if (line>=(int)mxc.cMultipleItems) return -1;

	// Cꗗ̏擾
	MIXERCONTROLDETAILS_LISTTEXT
		*list = (PMIXERCONTROLDETAILS_LISTTEXT)LocalAlloc(
			LPTR, sizeof(MIXERCONTROLDETAILS_LISTTEXT)*mxc.cMultipleItems);
	MIXERCONTROLDETAILS mxcd;
	mxcd.cbStruct = sizeof(mxcd);
	mxcd.dwControlID = mxc.dwControlID;
	mxcd.cChannels = 1;
	mxcd.cMultipleItems = mxc.cMultipleItems;
	mxcd.cbDetails = sizeof(*list);
	mxcd.paDetails = list;

	if (mixerGetControlDetails((HMIXEROBJ)dev,&mxcd,
		MIXER_OBJECTF_WAVEIN | MIXER_GETCONTROLDETAILSF_LISTTEXT)!=MMSYSERR_NOERROR) {
		LocalFree(list);
		return -1;
	}

	strcpy(buf,list[line].szName);
	LocalFree(list);

	return 0;
}

// ̓CI
EXPORT BOOL WINAPI w_in_selline(int dev, int line, int p3, int p4)
{
	o_devid = dev;
	// C
	MIXERLINE mxl;
	mxl.cbStruct = sizeof(MIXERLINE);
	mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN;
	if(mixerGetLineInfo((HMIXEROBJ)dev,&mxl,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINEINFOF_COMPONENTTYPE)!=MMSYSERR_NOERROR)
			return -1;

	// C̃Xg擾邽߂̃Rg[ID擾
	MIXERCONTROL mxc;
	MIXERLINECONTROLS mxlc;
	memset(&mxlc,0,sizeof(mxlc));
	mxlc.cbStruct = sizeof(MIXERLINECONTROLS);
	mxlc.dwLineID = mxl.dwLineID;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_MUX;
	mxlc.cControls = 1;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL);
	mxlc.pamxctrl = &mxc;

	if (mixerGetLineControls((HMIXEROBJ)dev,&mxlc,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINECONTROLSF_ONEBYTYPE)!=MMSYSERR_NOERROR)
			return -1;
	if (line>=(int)mxc.cMultipleItems) return -1;

	// C̏Ԃ̈ꗗ擾 or ݒ
	MIXERCONTROLDETAILS_BOOLEAN linet[MAX_LINE];
	MIXERCONTROLDETAILS mxcd;
	mxcd.cbStruct = sizeof(mxcd);
	mxcd.dwControlID = mxc.dwControlID;
	mxcd.cChannels = 1;
	mxcd.cMultipleItems = mxc.cMultipleItems;
	mxcd.cbDetails = sizeof(*linet);
	mxcd.paDetails = linet;

	if (line<0) {
		// ݂̃C
		if (mixerGetControlDetails((HMIXEROBJ)dev,&mxcd,
			MIXER_OBJECTF_WAVEIN | MIXER_GETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR)
				return 0;
		int i;
		for (i=0;i<(int)mxc.cMultipleItems;i++) {
			if(linet[i].fValue) {
				return -i;
			}
		}
		return 0;
	}


	// Zbg
	memset(linet,0,sizeof(linet));
	linet[line].fValue = TRUE;
	if (mixerSetControlDetails((HMIXEROBJ)dev,&mxcd,
		MIXER_OBJECTF_WAVEIN | MIXER_SETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR)
			return -1;
	return 0;
}

/*
  ʐݒ (ʂ)
1 Cꗗ擾
2 w肳ꂽԍɑΉLineID𒲂ׂ
3 LineID{[Rg[擾
4 {[ݒ
*/

EXPORT BOOL WINAPI w_in_setvol(int dev, int line, int vol, int p4)
{
	// C
	MIXERLINE mxl;
	mxl.cbStruct = sizeof(MIXERLINE);
	mxl.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_WAVEIN;
	if(mixerGetLineInfo((HMIXEROBJ)dev,&mxl,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINEINFOF_COMPONENTTYPE)!=MMSYSERR_NOERROR)
			return -1;

	// C̃Xg擾邽߂̃Rg[ID擾
	MIXERCONTROL mxc;
	MIXERLINECONTROLS mxlc;
	memset(&mxlc,0,sizeof(mxlc));
	mxlc.cbStruct = sizeof(MIXERLINECONTROLS);
	mxlc.dwLineID = mxl.dwLineID;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_MUX;
	mxlc.cControls = 1;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL);
	mxlc.pamxctrl = &mxc;

	if (mixerGetLineControls((HMIXEROBJ)dev,&mxlc,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINECONTROLSF_ONEBYTYPE)!=MMSYSERR_NOERROR)
			return -1;
	if (line>=(int)mxc.cMultipleItems) return -1;

	// Cꗗ̏擾
	MIXERCONTROLDETAILS_LISTTEXT
		*list = (PMIXERCONTROLDETAILS_LISTTEXT)LocalAlloc(
			LPTR, sizeof(MIXERCONTROLDETAILS_LISTTEXT)*mxc.cMultipleItems);
	MIXERCONTROLDETAILS mxcd;
	mxcd.cbStruct = sizeof(mxcd);
	mxcd.dwControlID = mxc.dwControlID;
	mxcd.cChannels = 1;
	mxcd.cMultipleItems = mxc.cMultipleItems;
	mxcd.cbDetails = sizeof(*list);
	mxcd.paDetails = list;

	if (mixerGetControlDetails((HMIXEROBJ)dev,&mxcd,
		MIXER_OBJECTF_WAVEIN | MIXER_GETCONTROLDETAILSF_LISTTEXT)!=MMSYSERR_NOERROR) {
		LocalFree(list);
		return -1;
	}

	int LineID = list[line].dwParam1;
	LocalFree(list);

	// LineID̃{[Rg[擾
	mxlc.dwLineID = LineID;
	mxlc.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
	mxlc.cControls = 1;
	mxlc.cbmxctrl = sizeof(MIXERCONTROL);
	mxlc.pamxctrl = &mxc;
	if(mixerGetLineControls((HMIXEROBJ)dev,&mxlc,
		MIXER_OBJECTF_WAVEIN | MIXER_GETLINECONTROLSF_ONEBYTYPE) != MMSYSERR_NOERROR)
			return -1;


	// {[擾 or ݒ
	MIXERCONTROLDETAILS_UNSIGNED mxcdVolume;
	mxcd.dwControlID = mxc.dwControlID;
	mxcd.cChannels = 1;
	mxcd.cMultipleItems = 0;
	mxcd.cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED);
	mxcd.paDetails = &mxcdVolume;

	if (vol<0) {
		// 擾
		if(mixerGetControlDetails((HMIXEROBJ)dev,&mxcd,
			 MIXER_OBJECTF_WAVEIN | MIXER_GETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR) return -1;
		return -(int)mxcdVolume.dwValue;
	}
	// ݒ
	mxcdVolume.dwValue=vol;
	if(mixerSetControlDetails((HMIXEROBJ)dev,&mxcd,
		 MIXER_OBJECTF_WAVEIN | MIXER_SETCONTROLDETAILSF_VALUE)!=MMSYSERR_NOERROR) return -1;

	return 0;
}



